/*
 * Copyright (C) 2025  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef CHECK_VALUE_HH_2D885394B38776289AD3CB52A01CFC4A//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define CHECK_VALUE_HH_2D885394B38776289AD3CB52A01CFC4A

#include "src/common_types.hh"

#include "libfred/opcontext.hh"

#include <string>
#include <vector>

namespace Fred {
namespace Registry {

bool is_country_code_valid(const LibFred::OperationContext& ctx, const CountryCode& cc);

bool is_postal_line_type(const std::string& value);

bool is_opt_postal_line_type(const std::string& value);

bool is_pc_type(const Fred::Registry::PostalCode& value);

bool is_e164_string_type(const Fred::Registry::PhoneNumber& phone_number);

bool is_email_comma_list_type(const std::vector<Fred::Registry::EmailAddress>& values);

bool is_vat_t(const Fred::Registry::VatIdentificationNumber& value);

bool is_ident_value_t(const std::string& value);

}//namespace Fred::Registry
}//namespace Fred

#endif//CHECK_VALUE_HH_2D885394B38776289AD3CB52A01CFC4A
